<#ibiztemplate>
TARGET=PSAPPDATAENTITY
</#ibiztemplate>
import { MockAdapter } from '@/mock/mock-adapter';
import { Util } from '@/ibiz-core/utils';
const mock = MockAdapter.getInstance();

// 模拟数据
const mockDatas: Array<any> = [
<#if de.getAllPSDESampleDatas?? &&  de.getAllPSDESampleDatas()??>
<#list de.getAllPSDESampleDatas() as data>
    ${data.getDataJO().toString()}<#if data_has_next>,</#if>
</#list>
</#if>
];

/**
 * 解析参数
 * 
 * @param paramArray 参数数组
 * @param regStr 路径正则
 * @param url 访问路径
 */
const parsingParameters = (paramArray: Array<string>, regStr: RegExp, url: string): any => {
    let params: any = {};
    const matchArray: any = new RegExp(regStr).exec(url);
    if (matchArray && matchArray.length > 1 && paramArray && paramArray.length > 0) {
        paramArray.forEach((item: any, index: number) => {
            Object.defineProperty(params, item, {
                enumerable: true,
                value: matchArray[index + 1],
            });
        });
    }
    return params;
};

/**
 * 排队路径参数是否存在 null、undefined 或者空字符串等异常情况 
 * 
 * @param paramArray 
 * @param params 
 */
const judgmentParametersException = (paramArray: Array<string>, params: any): boolean => {
    let isParametersException = false;
    if (paramArray.length > 0) {
        let state = paramArray.some((key: string) => {
            let _value = params[key];
            if (!_value || Object.is(_value, '')) {
                return true;
            }
            return false;
        });
        if (state) {
            isParametersException = true;;
        }
    }
    return isParametersException;
};

<#assign isCurWFDE = false>
<#if app.getAppMode()?? && app.getAppMode() == "WFAPP" && app.getAllPSAppWFs()??>
    <#list app.getAllPSAppWFs() as appwf>
        <#if appwf.getPSWorkflow().getWFProxyMode() == 3 && appwf.getPSWorkflow().getPSWFDEs()??>
            <#list appwf.getPSWorkflow().getPSWFDEs() as wfde>
                <#if wfde.getWFProxyMode() == 2 && wfde.getCodeName() == de.getCodeName()>
                    <#assign isCurWFDE = true>
                    <#break>
                </#if>
            </#list>
            <#if isCurWFDE>
                <#break>
            </#if>
        </#if>
    </#list>
</#if>
<#assign isClientWFDE = false>
<#if de.hasPSDEWF() && de.getAllPSDEWFs()??>
    <#list de.getAllPSDEWFs() as wfde>
        <#if wfde.getWFProxyMode() == 1 >
            <#assign isClientWFDE = true>
            <#break>
        </#if>
    </#list>
</#if>

<#assign keyCNLC = "id">
<#assign itemCodeName = item.getCodeName()>
<#assign itemCodeNameLC = itemCodeName?lower_case>

<#--  主实体  start -->
<#if item.isMajor()>
<#assign parentPath = ""  >
<#assign selfPath="\\/" + srfpluralize(itemCodeNameLC) >
<#assign parentParams = "">
<#assign parentSearchParams = "" >
<#assign parentParams2 = "">
<#assign parentParams3 = "">
<#assign idParams = "">
<#assign authParams = "">
<#assign idParams2 = "">
<#assign idParams3 = "">
<#assign etParams = "">
<#assign etParams2 = "">
<#assign etParams3 = "">
<#assign id_etParams = "">
<#assign id_etParams2 = "">
<#assign id_etParams3 = "">

<#assign etParams = etParams + "@RequestBody " + itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams2 = etParams2 +  itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams3 = etParams3 + "">
<#assign idParams = idParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign authParams = "#" + itemCodeNameLC + keyCNLC + ",">
<#assign idParams2 = idParams2 + " " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams3 = idParams3 + "'" + itemCodeNameLC + keyCNLC + "'" >
<#assign id_etParams = id_etParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", @RequestBody " + itemCodeName + " " + itemCodeNameLC + "" >
<#assign id_etParams2 = id_etParams2 + "" + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", " + itemCodeName + " " + itemCodeNameLC + "," >
<#assign id_etParams3 = id_etParams3 + "'" + itemCodeNameLC + keyCNLC + "'" >
<#assign fullPath = parentPath + selfPath>

<#if item.getAllPSAppDEMethods()??>
    <#list item.getAllPSAppDEMethods() as appMethod>
        <#if appMethod.getPSDEServiceAPIMethod()??>
            <#assign reqMtd = appMethod.getPSDEServiceAPIMethod().getRequestMethod()>
            <#if appMethod.getMethodType()=='DEACTION'>
                <#assign deaction = appMethod.getPSDEAction()>
                <#assign deactionName = deaction.getName()>
                <#assign deactionCodeName = deaction.getCodeName()>
                <#assign oppriv = "">
                <#if deaction.getPSDEOPPriv()??>
                    <#assign oppriv = deaction.getPSDEOPPriv().getName() >
                </#if>
                <#if deaction.codeName == 'Create'>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check('${oppriv}')")
    public ResponseEntity<${item.getCodeName()}> ${appMethod.getCodeName()?uncap_first}(${etParams}) {
        ${item.getCodeName()} ${item.getCodeName()?lower_case}2 = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}(${etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case}2);
    }  -->
//${deactionCodeName}
mock.on${reqMtd?lower_case?cap_first}(new RegExp(/^${fullPath}$/)).reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    // ${etParams3}
    let paramArray: Array<string> = [${etParams3}];
    let regStr: RegExp = /^${fullPath}$/;
    let url = config.url;
    let params = parsingParameters(paramArray, regStr, url);
    console.log(params);

    let state = judgmentParametersException(paramArray, params);
    if (state) {
        return [403, null, config.headers, config];
    }

    let data: any = JSON.parse(config.data);
    mockDatas.push(Object.assign({}, data, { ${itemCodeNameLC}${keyCNLC}: Util.createUUID() }))

    return [status, mockDatas[mockDatas.length - 1], config.headers, config];
});

                <#elseif deaction.codeName == 'Update'>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check(${authParams}'${oppriv}')")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${id_etParams}) {
        ${itemCodeName} ${itemCodeName?lower_case}2 = ${itemCodeName?lower_case}service.${deactionCodeName?uncap_first}(${id_etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case}2);
    }  -->
//${deactionCodeName}
mock.on${reqMtd?lower_case?cap_first}(new RegExp(/^${fullPath}\/([a-zA-Z0-9\-\;]{1,35})$/)).reply((config: any) => {
<#--  mock.on${reqMtd?lower_case?cap_first}('${fullPath}/{${itemCodeNameLC + keyCNLC}}').reply((config: any) => {  -->
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    // ${id_etParams3}
    let paramArray: Array<string> = [${id_etParams3}];
    let regStr: RegExp = /^${fullPath}\/([a-zA-Z0-9\-\;]{1,35})$/;
    let url = config.url;
    let params = parsingParameters(paramArray, regStr, url);
    console.log(params);

    let state = judgmentParametersException(paramArray, params);
    if (state) {
        return [403, null, config.headers, config];
    }

    // 遍历键值，获取数据
    let items: Array<any> = [];
    items = Util.deepCopy(mockDatas);
    let state2 = Object.keys(params).some((key: string) => {
        let _value = params[key];
        let _items = items.filter((data: any) => Object.is(data[key], _value));
        if (_items.length === 0) {
            return true;
        }
        items = [];
        items = Util.deepCopy(_items);
        return false;
    });
    if (state2) {
        return [403, null, config.headers, config];
    }

    let et_id = Object.keys(params)[Object.keys(params).length - 1]
    let et_id_value = params[et_id];
    let index = mockDatas.findIndex((data: any) => Object.is(data[et_id], et_id_value));

    let data: any = JSON.parse(config.data);
    Object.keys(mockDatas[index]).forEach((key: string) => {
        if (data.hasOwnProperty(key)) {
            Object.assign(mockDatas[index], { [key]: data[key] })
        }
    });

    return [status, mockDatas[index], config.headers, config];
});

                <#elseif deaction.codeName == 'Get'>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check(${authParams}'${oppriv}')")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${idParams}) {
        ${itemCodeName} ${itemCodeName?lower_case} = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}(${idParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case});
    }  -->
//${deactionCodeName}
mock.on${reqMtd?lower_case?cap_first}(new RegExp(/^${fullPath}\/([a-zA-Z0-9\-\;]{1,35})$/)).reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    // ${idParams3}
    let paramArray: Array<string> = [${idParams3}];
    let regStr: RegExp = /^${fullPath}\/([a-zA-Z0-9\-\;]{1,35})$/;
    let url = config.url;
    let params = parsingParameters(paramArray, regStr, url);
    console.log(params);

    let state = judgmentParametersException(paramArray, params);
    if (state) {
        return [403, null, config.headers, config];
    }

    // 遍历键值，获取数据
    let items: Array<any> = [];
    items = Util.deepCopy(mockDatas);
    let state2 = Object.keys(params).some((key: string) => {
        let _value = params[key];
        let _items = items.filter((data: any) => Object.is(data[key], _value));
        if (_items.length === 0) {
            return true;
        }
        items = [];
        items = Util.deepCopy(_items);
        return false;
    });
    if (state2) {
        return [403, null, config.headers, config];
    }
    return [status, items[0], config.headers, config];
});

                <#elseif deaction.codeName == 'GetDraft'>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check('${oppriv}')")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}() {
        //${itemCodeName} ${itemCodeName?lower_case} = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}(${idParams3});
        return ResponseEntity.status(HttpStatus.OK).body(new ${itemCodeName}());
    }  -->
//${deactionCodeName}
mock.on${reqMtd?lower_case?cap_first}(new RegExp(/^${fullPath}\/${deactionCodeName?lower_case}$/)).reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    // ${idParams3}
    <#--  let paramArray: Array<string> = [${idParams3}];  -->
    let paramArray: Array<string> = [];
    let regStr: RegExp = /^${fullPath}\/${deactionCodeName?lower_case}$/;
    let url = config.url;
    let params = parsingParameters(paramArray, regStr, url);
    console.log(params);

    let state = judgmentParametersException(paramArray, params);
    if (state) {
        return [403, null, config.headers, config];
    }

    return [status, {}, config.headers, config];
});

                <#elseif deaction.codeName == 'Remove'>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check(${authParams}'${oppriv}')")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}(${idParams}) {
        boolean b = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}(${idParams3});
        return ResponseEntity.status(HttpStatus.OK).body(b);
    }  -->
//${deactionCodeName}
mock.on${reqMtd?lower_case?cap_first}(new RegExp(/^${fullPath}\/([a-zA-Z0-9\-\;]{1,35})$/)).reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    // ${idParams3}
    let paramArray: Array<string> = [${idParams3}];
    let regStr: RegExp = /^${fullPath}\/([a-zA-Z0-9\-\;]{1,35})$/;
    let url = config.url;
    let params = parsingParameters(paramArray, regStr, url);
    console.log(params);

    let state = judgmentParametersException(paramArray, params);
    if (state) {
        return [403, null, config.headers, config];
    }

    let et_id = Object.keys(params)[Object.keys(params).length - 1]
    let et_id_value = params[et_id];
    let index = mockDatas.findIndex((data: any) => Object.is(data[et_id], et_id_value));
    mockDatas.splice(index, 1);

    return [status, null, config.headers, config];
});

               <#elseif deaction.codeName == 'CheckKey'>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check('${oppriv}')")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}(${etParams}) {
        boolean b = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}(${etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(b);
    }  -->
//${deactionCodeName}
mock.on${reqMtd?lower_case?cap_first}(new RegExp(/^${fullPath}\/${deactionCodeName?lower_case}$/)).reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    // ${etParams3}
    let paramArray: Array<string> = [${etParams3}];
    let regStr: RegExp = /^${fullPath}\/${deactionCodeName?lower_case}$/;
    let url = config.url;
    let params = parsingParameters(paramArray, regStr, url);
    console.log(params);

    let state = judgmentParametersException(paramArray, params);
    if (state) {
        return [403, null, config.headers, config];
    }

    return [status, {
    }];
});

                <#else>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/${deactionCodeName?lower_case}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check(${authParams}'${oppriv}')")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${id_etParams}) {
        ${itemCodeName} ${itemCodeName?lower_case}2 = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}(${id_etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case}2);
    }  -->
//${deactionCodeName}
mock.on${reqMtd?lower_case?cap_first}(new RegExp(/^${fullPath}\/([a-zA-Z0-9\-\;]{1,35})\/${deactionCodeName?lower_case}$/)).reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    // ${id_etParams3}
    let paramArray: Array<string> = [${id_etParams3}];
    let regStr: RegExp = /^${fullPath}\/([a-zA-Z0-9\-\;]{1,35})\/${deactionCodeName?lower_case}$/;
    let url = config.url;
    let params = parsingParameters(paramArray, regStr, url);
    console.log(params);

    let state = judgmentParametersException(paramArray, params);
    if (state) {
        return [403, null, config.headers, config];
    }

    return [status, {
    }];
});

                </#if>
            <#elseif appMethod.getMethodType()=='FETCH'>
                <#assign deds = appMethod.getPSDEDataSet()>
                <#assign oppriv = "">
                <#if deds.getPSDEOPPriv()??>
                    <#assign oppriv = deds.getPSDEOPPriv().getName() >
                </#if>
    <#--  @RequestMapping(method= RequestMethod.${reqMtd} , value="${fullPath}/fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()?lower_case}<#else>${deds.getCodeName()?lower_case}</#if>")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check('${oppriv}')")
	public ResponseEntity<List<${itemCodeName}>> ${appMethod.getCodeName()?uncap_first}(<#if parentParams!="">${parentParams},</#if>${itemCodeName}SearchContext searchContext,Pageable pageable) {
        ${parentSearchParams}
        Page<${itemCodeName}> page = ${item.getCodeName()?lower_case}service.fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>(<#if parentParams != "">${parentParams3} , </#if>searchContext);
        return ResponseEntity.status(HttpStatus.OK)
                .header("x-page", String.valueOf(pageable.getPageNumber()))
        		.header("x-per-page", String.valueOf(pageable.getPageSize()))
        		.header("x-total", String.valueOf(page.getTotalElements()))
        		.body(page.getContent());
    }  -->
//fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>
mock.on${reqMtd?lower_case?cap_first}(new RegExp(/^${fullPath}\/fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()?lower_case}<#else>${deds.getCodeName()?lower_case}</#if>(\?[\w-./?%&=]*)*$/)).reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    // ${parentParams3}
    let paramArray: Array<string> = [${parentParams3}];
    let regStr: RegExp = /^${fullPath}\/fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()?lower_case}<#else>${deds.getCodeName()?lower_case}</#if>(\?[\w-./?%&=]*)*$/;
    let url = config.url;
    let params = parsingParameters(paramArray, regStr, url);
    console.log(params);

    let state = judgmentParametersException(paramArray, params);
    if (state) {
        return [403, null, config.headers, config];
    }
    
    let { headers } = config;
    let xTotal = mockDatas.length;
    let records: Array<any> = [];
    if (config.url.includes('page')) {
        let url = config.url;
        let xPage = url.split('page=')[1];
        let xPerPage = url.split('size=')[1].split('&')[0];
        Object.assign(headers, { 'x-page': xPage + '', 'x-per-page': xPerPage + '', 'x-total': xTotal + '' });
        let start = xTotal - (xPage * xPerPage);
        records = mockDatas.slice(xPage * xPerPage, xPerPage);
    } else {
        records = [...mockDatas];
    }
    return [status, records, config.headers, config];
});

            </#if>
        <#else>
            <#if appMethod.getMethodType()=='DEACTION'>
                <#assign deaction = appMethod.getPSDEAction()>
                <#assign deactionName = deaction.getName()>
                <#assign deactionCodeName = deaction.getCodeName()>
                <#if deaction.codeName == 'Create'>
    <#--  public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${etParams}) {
        return null;
    }  -->

                <#elseif deaction.codeName == 'Update'>
    <#--  public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${id_etParams}) {
        return null;
    }  -->

                <#elseif deaction.codeName == 'Get'>
    <#--  public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${idParams}) {
        return null;
    }  -->

                <#elseif deaction.codeName == 'GetDraft'>
    <#--  public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}() {
        return null;
    }  -->

                <#elseif deaction.codeName == 'Remove'>
    <#--  public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}(${idParams}) {
        return null;
    }  -->

               <#elseif deaction.codeName == 'CheckKey'>
    <#--  public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}(${etParams}) {
        return null;
    }  -->

                <#else>

    <#--  public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}(${id_etParams}) {
        return null;
    }  -->

                </#if>
            <#elseif appMethod.getMethodType()=='FETCH'>
                <#assign deds = appMethod.getPSDEDataSet()>
	<#--  public ResponseEntity<List<${itemCodeName}>> ${appMethod.getCodeName()?uncap_first}() {
        return null;
    }  -->

            </#if>
        </#if>
    </#list>
</#if>
</#if>
<#--  主实体  end  -->

<#--  关系接口  start  -->
<#if item.getPSAppDERSPathCount() gt 0>
  <#list 0..1000 as x>
    <#if x gte item.getPSAppDERSPathCount()>
      <#break>
    <#else>
    <#assign parentPath = ""  >
        <#assign selfPath="/" + srfpluralize(itemCodeNameLC) >
        <#assign parentParams = "">
        <#assign byParams = "By">
        <#assign parentSearchParams = "" >
        <#assign parentParams2 = "">
        <#assign parentParams3 = "">
        <#assign parentAuthParams = "">
        <#assign parentAuthParams2 = "">
        <#assign idParams = "">
        <#assign authParams = "">
        <#assign idParams2 = "">
        <#assign idParams3 = "">
        <#assign etParams = "">
        <#assign etParams2 = "">
        <#assign etParams3 = "">
        <#assign id_etParams = "">
        <#assign id_etParams2 = "">
        <#assign id_etParams3 = "">
      <#list item.getPSAppDERSPath(x) as rs>
        <#assign rsMainAppDe = rs.getMajorPSAppDataEntity()>
        <#assign rsMainDe = rsMainAppDe.getPSDataEntity()>
        <#assign rsMainAppDeCN = rsMainAppDe.codeName >
        <#assign rsMainAppDeCNLC = rsMainAppDeCN?lower_case >
        <#assign rsMainDePKCN = rsMainDe.getKeyPSDEField().codeName >
        <#assign rsMainDePKCNLC = rsMainDePKCN?lower_case >
        <#assign rsMainDePKDataType = rsMainDe.getKeyPSDEField().stdDataType >
        <#assign parentPath += "/" + srfpluralize(rsMainAppDeCNLC)?lower_case + "/{" + rsMainAppDeCNLC + keyCNLC + "}" >
        <#if x != 0>
          <#assign parentParams += ", ">
        </#if>
        <#assign parentParams += "@PathVariable(\"" + rsMainAppDeCNLC + keyCNLC + "\") " + srfjavatype(rsMainDePKDataType) + " " + rsMainAppDeCNLC + keyCNLC >
        <#assign byParams += rsMainAppDeCN >
        <#assign parentAuthParams = parentAuthParams + "#" + rsMainAppDeCNLC + keyCNLC + ",">
        <#assign parentAuthParams2 = parentAuthParams2 + "#" + rsMainAppDeCNLC + keyCNLC + ",">
        <#if rs.getPSDER1N()??>
          <#assign parentSearchParams += "searchContext.setN_" + rs.getPSDER1N().getPSPickupDEField().getCodeName()?lower_case + "_eq("+ rsMainAppDeCNLC + keyCNLC +");" >
        </#if>
        <#assign parentParams2 += "" + srfjavatype(rsMainDePKDataType) + " " + rsMainAppDeCNLC + keyCNLC >
        <#assign parentParams3 += "" + rsMainAppDeCNLC + keyCNLC >

        <#if parentParams != "" >
          <#assign idParams = parentParams + ", ">
          <#assign idParams2 = parentParams2 + ", ">
          <#assign idParams3 = parentParams3 + ", ">
          <#assign etParams = parentParams + ", ">
          <#assign etParams2 = parentParams2 + ", ">
          <#assign etParams3 = parentParams3 + ", ">
          <#assign id_etParams = parentParams + ", ">
          <#assign id_etParams2 = parentParams2 + ", ">
          <#assign id_etParams3 = parentParams3 + ", ">
        </#if>
      </#list>
      <#assign etParams = etParams + "@RequestBody " + itemCodeName + " " + itemCodeNameLC + "">
        <#assign etParams2 = etParams2 +  itemCodeName + " " + itemCodeNameLC + "">
        <#assign etParams3 = etParams3 +  itemCodeNameLC + "">
        <#assign idParams = idParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
        <#assign authParams = "#" + itemCodeNameLC + keyCNLC + ",">
        <#assign idParams2 = idParams2 + " " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
        <#assign idParams3 = idParams3 + " " + itemCodeNameLC + keyCNLC >
        <#assign id_etParams = id_etParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", @RequestBody " + itemCodeName + " " + itemCodeNameLC + "" >
        <#assign id_etParams2 = id_etParams2 + "" + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", " + itemCodeName + " " + itemCodeNameLC + "" >
        <#assign id_etParams3 = id_etParams3 + "" + itemCodeNameLC + keyCNLC + ", " + itemCodeNameLC + "" >
        <#assign fullPath = parentPath + selfPath>
      <#if item.getAllPSAppDEMethods()??>
          <#list item.getAllPSAppDEMethods() as appMethod>
            <#if appMethod.getPSDEServiceAPIMethod()??>
            <#assign reqMtd = appMethod.getPSDEServiceAPIMethod().getRequestMethod()>
              <#if appMethod.getMethodType()=='DEACTION'>
                <#assign deaction = appMethod.getPSDEAction()>
                <#assign deactionName = deaction.getName()>
                <#assign deactionCodeName = deaction.getCodeName()>
                <#assign oppriv = "">
                <#if deaction.getPSDEOPPriv()??>
                    <#assign oppriv = deaction.getPSDEOPPriv().getName() >
                </#if>
                <#if deaction.codeName == 'Create'>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check${byParams}(${parentAuthParams2}'${oppriv}')")
    public ResponseEntity<${item.getCodeName()}> ${appMethod.getCodeName()?uncap_first}${byParams}(${etParams}) {
        ${item.getCodeName()} ${item.getCodeName()?lower_case}2 = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case}2);
    }  -->
//${deaction.codeName}
mock.on${reqMtd?lower_case?cap_first}('${fullPath}').reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    return [status, {
    }];
});

              <#elseif deaction.codeName == 'Update'>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check${byParams}(${parentAuthParams}${authParams}'${oppriv}')")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${id_etParams}) {
        ${itemCodeName} ${itemCodeName?lower_case}2 = ${itemCodeName?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${id_etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case}2);
    }  -->
//${deaction.codeName}
mock.on${reqMtd?lower_case?cap_first}('${fullPath}/{${itemCodeNameLC + keyCNLC}').reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    return [status, {
    }];
});

              <#elseif deaction.codeName == 'Get'>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check${byParams}(${parentAuthParams}${authParams}'${oppriv}')")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${idParams}) {
        ${itemCodeName} ${itemCodeName?lower_case} = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${idParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case});
    }  -->
//${deaction.codeName}
mock.on${reqMtd?lower_case?cap_first}('${fullPath}/{${itemCodeNameLC + keyCNLC}').reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    return [status, {
    }];
});

              <#elseif deaction.codeName == 'GetDraft'>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check${byParams}(${parentAuthParams2}'${oppriv}')")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}() {
        //${itemCodeName} ${itemCodeName?lower_case} = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${idParams3});
        return ResponseEntity.status(HttpStatus.OK).body(new ${itemCodeName}());
    }  -->
//${deaction.codeName}
mock.on${reqMtd?lower_case?cap_first}('${fullPath}/${deactionCodeName?lower_case}').reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    return [status, {
    }];
});

              <#elseif deaction.codeName == 'Remove'>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check${byParams}(${parentAuthParams}${authParams}'${oppriv}')")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${idParams}) {
        boolean b = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${idParams3});
        return ResponseEntity.status(HttpStatus.OK).body(b);
    }  -->
//${deaction.codeName}
mock.on${reqMtd?lower_case?cap_first}('${fullPath}/{${itemCodeNameLC + keyCNLC}}').reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    return [status, {
    }];
});

              <#elseif deaction.codeName == 'CheckKey'>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check${byParams}(${parentAuthParams2}'${oppriv}')")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${etParams}) {
        boolean b = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(b);
    }  -->
//${deaction.codeName}
mock.on${reqMtd?lower_case?cap_first}('${fullPath}/${deactionCodeName?lower_case}').reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    return [status, {
    }];
});

              <#else>
	<#--  @RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/${deactionCodeName?lower_case}")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check${byParams}(${parentAuthParams}${authParams}'${oppriv}')")
    public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${id_etParams}) {
        ${itemCodeName} ${itemCodeName?lower_case}2 = ${item.getCodeName()?lower_case}service.${deactionCodeName?uncap_first}${byParams}(${id_etParams3});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeName?lower_case}2);
    }  -->
//${deaction.codeName}
mock.on${reqMtd?lower_case?cap_first}('${fullPath}/{${itemCodeNameLC + keyCNLC}}/${deactionCodeName?lower_case}').reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    return [status, {
    }];
});

              </#if>
            <#elseif appMethod.getMethodType()=='FETCH'>
              <#assign deds = appMethod.getPSDEDataSet()>
              <#if deds.getPSDEOPPriv()??>
                    <#assign oppriv = deds.getPSDEOPPriv().getName() >
                </#if>
    <#--  @RequestMapping(method= RequestMethod.${reqMtd} , value="${fullPath}/fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()?lower_case}<#else>${deds.getCodeName()?lower_case}</#if>")
    @PreAuthorize("@${item.getCodeName()?lower_case}_pms.check${byParams}(${parentAuthParams2}'${oppriv}')")
	public ResponseEntity<List<${itemCodeName}>> ${appMethod.getCodeName()?uncap_first}${byParams}(<#if parentParams!="">${parentParams},</#if>${itemCodeName}SearchContext searchContext,Pageable pageable) {
        ${parentSearchParams}
        Page<${itemCodeName}> page = ${item.getCodeName()?lower_case}service.fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>${byParams}(<#if parentParams != "">${parentParams3} , </#if>searchContext);
        return ResponseEntity.status(HttpStatus.OK)
                .header("x-page", String.valueOf(pageable.getPageNumber()))
        		.header("x-per-page", String.valueOf(pageable.getPageSize()))
        		.header("x-total", String.valueOf(page.getTotalElements()))
        		.body(page.getContent());
    }  -->
//${deaction.codeName}
mock.on${reqMtd?lower_case?cap_first}('${fullPath}/fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()?lower_case}<#else>${deds.getCodeName()?lower_case}</#if>').reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    if (status !== 200) {
        return [status, null];
    }
    return [status, {
    }];
});

            </#if>
          <#else>
            <#if appMethod.getMethodType()=='DEACTION'>
                <#assign deaction = appMethod.getPSDEAction()>
                <#assign deactionName = deaction.getName()>
                <#assign deactionCodeName = deaction.getCodeName()>
                <#if deaction.codeName == 'Create'>
    <#--  public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${etParams}) {
        return null;
    }  -->

                <#elseif deaction.codeName == 'Update'>
    <#--  public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${id_etParams}) {
        return null;
    }  -->

                <#elseif deaction.codeName == 'Get'>
    <#--  public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${idParams}) {
        return null;
    }  -->

                <#elseif deaction.codeName == 'GetDraft'>
    <#--  public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}() {
        return null;
    }  -->

                <#elseif deaction.codeName == 'Remove'>
    <#--  public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${idParams}) {
        return null;
    }  -->

               <#elseif deaction.codeName == 'CheckKey'>
    <#--  public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${etParams}) {
        return null;
    }  -->

                <#else>

    <#--  public ResponseEntity<${itemCodeName}> ${appMethod.getCodeName()?uncap_first}${byParams}(${id_etParams}) {
        return null;
    }  -->

                </#if>
            <#elseif appMethod.getMethodType()=='FETCH'>
                <#assign deds = appMethod.getPSDEDataSet()>
	<#--  public ResponseEntity<List<${itemCodeName}>> ${appMethod.getCodeName()?uncap_first}${byParams}() {
        return null;
    }  -->

            </#if>
        </#if>
    </#list>
    </#if>
    </#if>
  </#list>
</#if>
<#--  关系接口  end  -->

<#assign isCurWFDE = false>
<#if app.getAppMode()?? && app.getAppMode() == "WFAPP" && app.getAllPSAppWFs()??>
    <#list app.getAllPSAppWFs() as appwf>
        <#if appwf.getPSWorkflow().getWFProxyMode() == 3 && appwf.getPSWorkflow().getPSWFDEs()??>
            <#list appwf.getPSWorkflow().getPSWFDEs() as wfde>
                <#if wfde.getWFProxyMode() == 2 && wfde.getCodeName() == de.getCodeName()>
                    <#assign isCurWFDE = true>
                    <#break>
                </#if>
            </#list>
            <#if isCurWFDE>
                <#break>
            </#if>
        </#if>
    </#list>
</#if>

<#if isCurWFDE>
    <#assign itemPKParam = itemCodeNameLC + keyCNLC>
    <#assign wfFuncParams = "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemPKParam + ", @RequestBody JSONObject data">
    <#assign wfFuncParams2 = itemPKParam + ", data">

    /** 工作流行为 **/

    /**
     * 开始流程【WFStart】
     */
    <#--  @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfstart")
    public ResponseEntity<JSONObject> wfStart(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfStart(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }  -->

    /**
     * 流程处理【WFSubmit】
     */
    <#--  @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfsubmit")
    public ResponseEntity<JSONObject> wfSubmit(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfSubmit(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }  -->

    /**
     * 流程结束【WFClose】
     */
    <#--  @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfclose")
    public ResponseEntity<JSONObject> wfClose(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfClose(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }  -->

    /**
     * 流程跳转【WFGoto】
     */
    <#--  @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfgoto")
    public ResponseEntity<JSONObject> wfGoto(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfGoto(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }  -->

    /**
     * 流程重启【WFRestart】
     */
    <#--  @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfrestart")
    public ResponseEntity<JSONObject> wfRestart(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfRestart(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }  -->

    /**
     * 流程撤回【WFRollback】
     */
    <#--  @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfrollback")
    public ResponseEntity<JSONObject> wfRollback(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfRollback(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }  -->

    /**
     * 流程退回【WFSendBack】
     */
    <#--  @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfsendback")
    public ResponseEntity<JSONObject> wfSendBack(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfSendBack(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }  -->

    /**
     * 流程重新分配【WFReassign】
     */
    <#--  @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfreassign")
    public ResponseEntity<JSONObject> wfReassign(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfReassign(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }  -->

    /**
     * 流程标记已读【WFMarkRead】
     */
    <#--  @RequestMapping(method = RequestMethod.POST, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/wfmarkread")
    public ResponseEntity<JSONObject> wfMarkRead(${wfFuncParams}) {
        if (${item.getCodeName()?lower_case}service.wfMarkRead(${wfFuncParams2})) {
            return ResponseEntity.status(HttpStatus.OK).body(data);
        } else {
            return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(data);
        }
    }  -->

</#if>
<#--  客户端 流程 实体 启动  -->
<#if isClientWFDE>
    <#--  @RequestMapping(method= RequestMethod.GET , value="${fullPath}/wfstart")
	public ResponseEntity<JSONObject> wfStart() {
        return ResponseEntity.status(HttpStatus.OK).body(${item.getCodeName()?lower_case}service.wfStart());
    }  -->
</#if>
